-- Reconnect-Restore by MikuAuahDark

Recs=Recs or {}
Recs.Data={}					-- {health,armor,money,maxhealth,team,usgn,ip,x,y,weapon{[weapon_type_id]={current ammo,stored ammo}},current weapon id,nightvision,defuse kit,gasmask,addtional_data{order_by_Recs.AddtionalData}
Recs.TimeData={}				-- [Recs.Data Index]={timer_id}

-- User Configuration -- UConfig
Recs.Permissions=false			-- Use VADemon's permissions if available. Permission is "reconnect.restore"
Recs.IPMatch=3					-- Match only x sequence of ip. If you only expect static ip, set this to 4.
Recs.Timeout=60					-- Timeout before data is deleted in seconds.
Recs.AddtionalData={			-- In here, you can add table reference for addtional data that retrieved(Array where key/index=player id)
}
--[[ Example above:
Recs.AddtionalData={
	rp_addons,
	rp_ct,
}
]]
-- End UConfig

-- Add timerEx if not available
__timerArg=__timerArg or {}

timerEx=timerEx or function(ms,func,count,...)
	count=count or 1
	if count==0 then count=-1 end
	local tmpfunc,id="",0
	local random=math.random
	local char=string.char
	for i=1,8 do
		local rand=random(0,2)
		if rand==0 then
			tmpfunc=tmpfunc..char(random(65,90))
		elseif rand==1 then
			tmpfunc=tmpfunc..char(random(97,112))
		else
			tmpfunc=tmpfunc..random(0,9)
		end
	end
	table.insert(__timerArg,{type(func),tmpfunc,func,{...},count})
	for n,v in pairs(__timerArg) do
		if v[2]==tmpfunc then
			id=n
			break
		end
	end
	_G[tmpfunc]=function(id)
		id=tonumber(id)
		local ta=__timerArg
		if ta[id][1]=="function" then
			ta[id].r=ta[id][3](unpack(ta[id][4]))
		elseif ta[id][1]=="string" or ta[id][1]=="number" then
			ta[id].r=loadstring("return "..ta[id][3].."(unpack(__timerArg["..id.."][4]))")()
		end
		ta[id][5]=ta[id][5]-1
		if ta[id][5]==0 then
			_G[ta[id][2]]=nil
			ta[id]=nil
		end
	end
	timer(ms,tmpfunc,id,count)
	return id
end

freetimerEx=freetimerEx or function(id)
	local ta=__timerArg
	if ta[id]~=nil then
		freetimer(ta[id][2],id)
		_G[ta[id][2]]=nil
		ta[id]=nil
		return true
	end
	return false
end

-- Add LogCapture
if not LogCapture then

LogCapture={}
LogCapture.val={}
LogCapture.m=0
LogCapture.r=0

function LogCapture.Log(text)
	if LogCapture.m==1 then
		table.insert(LogCapture.val,text)
		return LogCapture.r
	end
end

setmetatable(LogCapture,{
	__call=function(_,command,keep_log)
		if not keep_log then
			LogCapture.r=1
		end
		LogCapture.m=1
		parse(command)
		LogCapture.m=0
		LogCapture.r=0
		local temp=LogCapture.val
		LogCapture.val={}
		return table.concat(temp,"\n")
	end
})

addhook("log","LogCapture.Log")

end

local function is_permitted(id)
	if Recs.Permissions==false then return true end
	local p=(permissions or{}).check
	if p==nil then return true end
	return p(id,"reconnect.restore",true)
end

local function restore(id,n,v)
	for a,b in pairs(v[15]) do
		Recs.AddtionalData[a][id]=b
	end
	if v[5]>0 then
		parse("make"..(v[5]>1 and "ct" or "t").." "..id)
		if v[12] then
			parse("spawnitem 59 "..math.floor(v[8]/32).." "..math.floor(v[9]/32))
		end
		if v[13] then
			parse("spawnitem 56 "..math.floor(v[8]/32).." "..math.floor(v[9]/32))
		end
		if v[14] then
			parse("spawnitem 60 "..math.floor(v[8]/32).." "..math.floor(v[9]/32))
		end
		parse("spawnplayer "..id.." "..v[8].." "..v[9])
		parse("setmaxhealth "..id.." "..v[4])
		parse("sethealth "..id.." "..v[1])
		parse("setarmor "..id.." "..v[2])
		for a,b in pairs(v[10]) do
			print(a.."\t"..tostring(b))
			print(b[1].."\t"..b[2])
			parse("equip "..id.." "..a)
			parse("setammo "..id.." "..a.." "..table.concat(b," "))
		end
		parse("setweapon "..id.." "..v[11])
	end
	parse("setmoney "..id.." "..v[3])
	Recs.Data[n]=nil
end

function Recs.Leave(id,r)
	if (r==1 or r==9) and is_permitted(id) then		-- Timeout related
		local temp2={}
		local weapon={}
		local temp={
			player(id,"health"),
			player(id,"armor"),
			player(id,"money"),
			player(id,"maxhealth"),
			player(id,"team"),
			player(id,"usgn"),
			player(id,"ip"),
			player(id,"x"),
			player(id,"y"),
			weapon,
			player(id,"weapon"),
			player(id,"nightvision"),
			player(id,"defusekit"),
			player(id,"gasmask"),
			temp2
		}
		do
			local w_list=LogCapture("items")
			for w in w_list:gmatch("[^\n]+") do
				print(w.."\t"..tostring(w:match("Titem: #0, pl: "..id)))
				if w:match("Titem: #0, pl: "..id) then
					local t,ain,a=w:match("Titem: #0, pl: %d+, typ: (%d*) %([^,]*%), a: (%d*)|(%d*)")
					weapon[tonumber(t)]={tonumber(ain),tonumber(a)}
				end
			end
		end
		for n,v in pairs(Recs.AddtionalData) do
			table.insert(temp2,v[id])
		end
		local id=0
		table.insert(Recs.Data,temp)
		for n,v in pairs(Recs.Data) do
			if v==temp then
				id=n
				break
			end
		end
		Recs.TimeData[id]=timerEx(Recs.Timeout*1000,function()Recs.TimeData[id]=nil Recs.Data[id]=nil end)
	end
end

function Recs.Join(id)
	if is_permitted(id) then
		local ur_usgn=player(id,"usgn")
		local ur_ip=player(id,"ip")
		local f=false
		for n,v in pairs(Recs.Data) do
			if f==true then break end
			if v[6]==ur_usgn then
				local ip1={string.match(v[7],"(%d+)%.(%d+)%.(%d+)%.(%d+)")}
				local ip2={string.match(ur_ip,"(%d+)%.(%d+)%.(%d+)%.(%d+)")}
				local non_match=false
				for i=1,Recs.IPMatch do
					if ip1[i]~=ip2[i] then
						non_match=true
						break
					end
				end
				if non_match==false then
					freetimerEx(Recs.TimeData[n])
					-- Restore player status
					print("OK: "..v[5])
					timerEx(100,restore,1,id,n,v)
				end
			end
		end
	end
end

addhook("leave","Recs.Leave")
addhook("join","Recs.Join")